/*
  BG Cache Children Comp
    あかつきみさき（みくちぃP）

  このスクリプトについて
    アクティブなコンポジションに含まれるコンポジションをバックグラウンドでキャッシュするスクリプト.

  動作環境
    日本語版 Adobe After Effects CS6以上

  使用方法
    スクリプトを実行.

  バージョン情報
    2018/06/19 Ver 1.0.0 Release
*/
/// <reference path="C:\Users\RUI\OneDrive\lib\aftereffects.d.ts\ae.d.ts"/>
(function () {
    CompItem.prototype.createChash = function () {
        //"ワークエリアをバックグラウンドでキャッシュ"
        app.executeCommand(app.findMenuCommandId("ワークエリアをバックグラウンドでキャッシュ"));
        var addedItemIds = [];
        var existsId = false;
        for (var i = 1; i <= this.layers.length; i++) {
            if (this.layer(i).source instanceof CompItem) {
                for (var j = 0; j < addedItemIds.length; j++) {
                    if (addedItemIds[j] == this.layer(i).source.id) {
                        existsId = true;
                        break;
                    }
                }
                if (existsId) {
                    existsId = false;
                    continue;
                }
                addedItemIds[addedItemIds.length] = this.layer(i).source.id;
                this.layer(i).source.createChash();
                // ビューワーで開く
                this.layer(i).source.openInViewer();
                // タイムラインパネルにフォーカス
                app.executeCommand(app.findMenuCommandId("タイムライン: " + this.layer(i).source.name));
                // タイムラインパネルを閉じる
                app.executeCommand(app.findMenuCommandId("タイムライン: " + this.layer(i).source.name));
            }
        }
    };
    var actComp = app.project.activeItem;
    if (actComp == null && !(actComp instanceof CompItem)) {
        return 0;
    }
    actComp.createChash();
}).call(this);
/*
  BG Cache Children Comp
    あかつきみさき（みくちぃP）

  このスクリプトについて
    アクティブなコンポジションに含まれるコンポジションをバックグラウンドでキャッシュするスクリプト.

  動作環境
    日本語版 Adobe After Effects CS6以上

  使用方法
    スクリプトを実行.

  バージョン情報
    2018/03/04 Ver 1.0.0 Release
*/
/// <reference path="C:\Users\RUI\OneDrive\lib\aftereffects.d.ts\ae.d.ts"/>
(function () {
    CompItem.prototype.createChash = function () {
        //"ワークエリアをバックグラウンドでキャッシュ"
        app.executeCommand(app.findMenuCommandId("ワークエリアをバックグラウンドでキャッシュ"));
        var addedItemIds = [];
        var existsId = false;
        for (var i = 1; i <= this.layers.length; i++) {
            if (this.layer(i).source instanceof CompItem) {
                for (var j = 0; j < addedItemIds.length; j++) {
                    if (addedItemIds[j] == this.layer(i).source.id) {
                        existsId = true;
                        break;
                    }
                }
                if (existsId) {
                    existsId = false;
                    continue;
                }
                addedItemIds[addedItemIds.length] = this.layer(i).source.id;
                this.layer(i).source.createChash();
                // ビューワーで開く
                this.layer(i).source.openInViewer();
                // タイムラインパネルにフォーカス
                app.executeCommand(app.findMenuCommandId("タイムライン: " + this.layer(i).source.name));
                // タイムラインパネルを閉じる
                app.executeCommand(app.findMenuCommandId("タイムライン: " + this.layer(i).source.name));
            }
        }
    };
    var actComp = app.project.activeItem;
    if (actComp == null && !(actComp instanceof CompItem)) {
        return 0;
    }
    actComp.createChash();
}).call(this);
